/*
 * SuperOfferSupplierListener.java
 *
 * Created on 17 de agosto de 2004, 13:31
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.SuperOffer;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.database.Transaction;

/**
 * Este servlet es el encargado de reaccionar ante la petición del proveedor de
 * modificar una supeoferta, es el encargado de preparar toda la información que
 * requiere <CODE>modificarsuperoferta.jsp</CODE>
 * 
 * @author andres
 */
public class SuperOfferSupplierListener extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones de los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método crea un objeto <CODE>SupperOffer</CODE> para cargar los
	 * datos de la superoferta especificada por el proveedor por medio del
	 * identificador único de la superoferta para que este objeto contenga la
	 * información base para <CODE>modificarsuperoferta.jsp</CODE>
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				String operationType = "";
	
				if( request.getParameter("operationType") != null )
				{
					operationType = request.getParameter("operationType");
				}
	
				url = "/proveedor/modificarsuperoferta.jsp";
	
				if( operationType.equals("update") )
				{
					SuperOffer superOffer = new SuperOffer(new Integer(request
							.getParameter("superOfferId")).intValue());
					superOffer.setProductId(new Integer(request
							.getParameter("superItem")).intValue());
					Transaction t = new Transaction();
					superOffer.update(t);
	
					if( !t.execute() )
					{
						//Fallo al actualizar el producto de la superOferta
						message = MessageBuilder.buildMessage(7);
					}
					else
					{
						//Todo OK
						message = MessageBuilder.buildMessage(4);
						superOffer = new SuperOffer(new Integer(request
								.getParameter("superOfferId")).intValue());
						request.setAttribute("superOffer", superOffer);
					}
				}
				else
				{
					SuperOffer superOffer = new SuperOffer(new Integer(request
							.getParameter("key")).intValue());
					if( superOffer == null )
					{
						//Fallo en la carga de la información de la superoferta
						//message = "Fallo en la carga de la información de la
						// superoferta";
						message = MessageBuilder.buildMessage(6);
	
					}
					else
					{
						//Todo OK
						//message = "La carga de la superoferta finalizó
						// correctamente";
						//message = MessageBuilder.buildMessage(3);
						message = "";
						request.setAttribute("superOffer", superOffer);
					}
				}
	
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo enla operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura mediante el
	 *             flujo <CODE>PrintWriter</CODE> en response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}